stages:
  - kaniko-build-unhardened
  - kaniko-build-bsi

kaniko-build-unhardened:
  #tags: ["standard-image"]
  variables:
    KANIKO_ARGS: "" #"--build-arg DEBIANCODE=bullseye --destination $CI_REGISTRY_IMAGE:bullseye"
    KANIKO_BUILD_CONTEXT: $CI_PROJECT_DIR/unhardened
  stage: kaniko-build-unhardened
  image:
    # For latest releases see https://github.com/GoogleContainerTools/kaniko/releases
    # Only debug/*-debug versions of the Kaniko image are known to work within Gitlab CI
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    # Default logic
    # Compose docker tag name
    # Git Branch/Tag to Docker Image Tag Mapping
    #   * Default Branch: main -> latest
    #   * Branch: feature/my-feature -> branch-feature-my-feature
    #   * Tag: v1.0.0/beta2 -> v1.0.0-beta2
    - |
      VERSION=$(date -u +"%Y%m%d%H%M%S")
      export IMAGE_TAG=$CI_REGISTRY_IMAGE:0.0.0-$VERSION-unhardened
      export IMAGE_ROLLINGTAG_PREFIX=$CI_REGISTRY_IMAGE:
    - echo $IMAGE_TAG
    - mkdir -p /kaniko/.docker
    # Write credentials to access Gitlab Container Registry within the runner/ci
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"auth\":\"$(echo -n ${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD} | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    # Build and push the container. To disable push add --no-push
    - DOCKERFILE_PATH=${DOCKERFILE_PATH:-"$KANIKO_BUILD_CONTEXT/Dockerfile"}
    # Workaroud for Kaniko and Kubernetes-Secrets mounted under /var/run
    - mv /var /var.orig
    - /kaniko/executor --force --context $KANIKO_BUILD_CONTEXT --dockerfile $DOCKERFILE_PATH --destination $IMAGE_TAG --destination ${IMAGE_ROLLINGTAG_PREFIX}15.4-unhardened $KANIKO_ARGS
  # Run this job in a branch/tag where a Dockerfile exists
  rules:
    - exists:
        - unhardened/Dockerfile
    # custom Dockerfile path
    - if: $DOCKERFILE_PATH
    # custom build context without an explicit Dockerfile path
    - if: $KANIKO_BUILD_CONTEXT != $CI_PROJECT_DIR
kaniko-build-bsi:
  #tags: ["standard-image"]
  variables:
    KANIKO_ARGS: "" #"--build-arg DEBIANCODE=bullseye --destination $CI_REGISTRY_IMAGE:bullseye"
    KANIKO_BUILD_CONTEXT: $CI_PROJECT_DIR
  stage: kaniko-build-bsi
  image:
    # For latest releases see https://github.com/GoogleContainerTools/kaniko/releases
    # Only debug/*-debug versions of the Kaniko image are known to work within Gitlab CI
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    # Default logic
    # Compose docker tag name
    # Git Branch/Tag to Docker Image Tag Mapping
    #   * Default Branch: main -> latest
    #   * Branch: feature/my-feature -> branch-feature-my-feature
    #   * Tag: v1.0.0/beta2 -> v1.0.0-beta2
    - |
      VERSION=$(date -u +"%Y%m%d%H%M%S")
      export IMAGE_TAG=$CI_REGISTRY_IMAGE:0.0.0-$VERSION
      export IMAGE_ROLLINGTAG_PREFIX=$CI_REGISTRY_IMAGE:
    - echo $IMAGE_TAG
    - mkdir -p /kaniko/.docker
    # Write credentials to access Gitlab Container Registry within the runner/ci
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"auth\":\"$(echo -n ${CI_REGISTRY_USER}:${CI_REGISTRY_PASSWORD} | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    # Build and push the container. To disable push add --no-push
    - DOCKERFILE_PATH=${DOCKERFILE_PATH:-"$KANIKO_BUILD_CONTEXT/Dockerfile"}
    # Workaroud for Kaniko and Kubernetes-Secrets mounted under /var/run
    - mv /var /var.orig
    - /kaniko/executor --force --context $KANIKO_BUILD_CONTEXT --dockerfile $DOCKERFILE_PATH --destination $IMAGE_TAG --destination ${IMAGE_ROLLINGTAG_PREFIX}15.4 $KANIKO_ARGS
  # Run this job in a branch/tag where a Dockerfile exists
  rules:
    - exists:
        - Dockerfile
    # custom Dockerfile path
    - if: $DOCKERFILE_PATH
    # custom build context without an explicit Dockerfile path
    - if: $KANIKO_BUILD_CONTEXT != $CI_PROJECT_DIR
